From 11e58e3b23e91faeac8aa093eb1c2f4504fba07a Mon Sep 17 00:00:00 2001
From: Bohyun Lee <bohyun.lee@databricks.com>
Date: Fri, 31 Jul 2026 14:21:53 +0200
Subject: [PATCH] Add pg_upgrade --wal-upgrade: capture a major-version upgrade
 as WAL

pg_upgrade normally reinitializes the new cluster with a fresh system
identifier and WAL history, which breaks LSN continuity at the upgrade
boundary: a base backup taken before the upgrade cannot be replayed into
the upgraded cluster, and every streaming standby must be rebuilt by
copying the whole data directory.  --wal-upgrade instead records the
upgrade as a replayable WAL "window" so the transformation can be
streamed and replayed like ordinary WAL.

The upgrade runs as usual, then a burst server started in binary-upgrade
mode emits the whole window (CN..COMPLETE) in one gated backend call
using a new RM_PG_UPGRADE_ID resource manager: rewritten catalog/system
files travel as full-page images (RELFILE_DATA), SLRUs as bulk segment
images (SLRU_DATA), non-relation files (pg_filenode.map, PG_VERSION) as
raw images (RAWFILE), and the directory skeleton as DIRTREE.  User
relations, which pg_upgrade transfers verbatim, are not carried as data;
their identities are logged in a RELINK manifest so a streaming standby
relinks them from its own retained old data directory (reproducing the
primary's transfer mode).  START/COMPLETE markers plus durable
upgrade_started / upgrade_finalized flags in pg_control make a crashed
partial upgrade detectable and refused rather than auto-served.

On recovery the new binary derives the end-of-upgrade checkpoint (CN)
in-process and arms pg_control to replay the window, supporting three
paths: local first-start, a fresh streaming-standby skeleton (armed via
the pg_upgrade.signal sentinel plus pg_upgrade_standby_old_datadir /
pg_upgrade_standby_transfer_mode GUCs), and cross-version archive PITR
(pg_control is synthesized so the version gate passes, then recovery
flows organically through CN).  --wal-upgrade-signal-handoff emits a
handoff record into the old primary's WAL so a physical standby pauses
cleanly at the boundary.

Bumps PG_CONTROL_VERSION and CATALOG_VERSION_NO.

Co-authored-by: Isaac
---
 doc/src/sgml/ref/pgupgrade.sgml                 |  133 +++
 src/backend/access/rmgrdesc/Makefile            |    1 +
 src/backend/access/rmgrdesc/meson.build         |    1 +
 src/backend/access/rmgrdesc/pgupgradedesc.c     |  170 ++++
 src/backend/access/rmgrdesc/xlogdesc.c          |   11 +
 src/backend/access/transam/Makefile             |    3 +-
 src/backend/access/transam/clog.c               |   10 +
 src/backend/access/transam/meson.build          |    1 +
 src/backend/access/transam/multixact.c          |   17 +
 src/backend/access/transam/pgupgrade_wal.c      | 1963 +++++++++++++++++++++++++++++++++++++++++++
 src/backend/access/transam/rmgr.c               |    1 +
 src/backend/access/transam/slru.c               |   71 ++
 src/backend/access/transam/xlog.c               | 1289 +++++++++++++++++++++++++++-
 src/backend/access/transam/xlogfuncs.c          |  465 ++++++++++
 src/backend/access/transam/xlogrecovery.c       |   32 +
 src/backend/postmaster/postmaster.c             |    7 +
 src/backend/postmaster/startup.c                |   11 +
 src/backend/replication/walsender.c             |    1 +
 src/backend/storage/buffer/bufmgr.c             |   25 +
 src/backend/utils/adt/pg_upgrade_support.c      |   30 +
 src/backend/utils/init/miscinit.c               |   86 ++
 src/backend/utils/misc/guc_parameters.dat       |   15 +
 src/backend/utils/misc/postgresql.conf.sample   |    8 +
 src/bin/initdb/initdb.c                         |    6 +
 src/bin/pg_controldata/pg_controldata.c         |    4 +
 src/bin/pg_ctl/pg_ctl.c                         |   17 +
 src/bin/pg_resetwal/pg_resetwal.c               |   42 +-
 src/bin/pg_upgrade/Makefile                     |    1 +
 src/bin/pg_upgrade/check.c                      |   47 ++
 src/bin/pg_upgrade/controldata.c                |    9 +
 src/bin/pg_upgrade/file.c                       |   67 +-
 src/bin/pg_upgrade/info.c                       |   87 +-
 src/bin/pg_upgrade/meson.build                  |    4 +
 src/bin/pg_upgrade/option.c                     |   75 +-
 src/bin/pg_upgrade/pg_upgrade.c                 |  790 ++++++++++++++++-
 src/bin/pg_upgrade/pg_upgrade.h                 |   55 ++
 src/bin/pg_upgrade/relfilenumber.c              |    1 +
 src/bin/pg_upgrade/revertable.c                 |  129 +++
 src/bin/pg_upgrade/server.c                     |   54 +-
 src/bin/pg_upgrade/t/009_initdb_option.pl       |  218 +++++
 src/bin/pg_upgrade/t/010_wal_upgrade.pl         |  669 +++++++++++++++
 src/bin/pg_upgrade/t/011_wal_upgrade_standby.pl |  753 +++++++++++++++++
 src/bin/pg_waldump/pgupgradedesc.c              |    1 +
 src/bin/pg_waldump/rmgrdesc.c                   |    1 +
 src/bin/pg_waldump/t/001_basic.pl               |    3 +-
 src/common/file_utils.c                         |  124 +++
 src/include/access/clog.h                       |    3 +
 src/include/access/multixact.h                  |    4 +
 src/include/access/pgupgrade_wal.h              |   98 +++
 src/include/access/rmgrlist.h                   |    2 +
 src/include/access/slru.h                       |    4 +
 src/include/access/xlog.h                       |   74 ++
 src/include/access/xlogrecovery.h               |    7 +
 src/include/catalog/catversion.h                |    2 +-
 src/include/catalog/pg_control.h                |  216 ++++-
 src/include/catalog/pg_proc.dat                 |    8 +
 src/include/common/file_utils.h                 |   17 +
 src/include/utils/guc.h                         |    1 +
 src/tools/pgindent/typedefs.list                |   15 +
 59 files changed, 7871 insertions(+), 88 deletions(-)

diff --git a/doc/src/sgml/ref/pgupgrade.sgml b/doc/src/sgml/ref/pgupgrade.sgml
index e4e8c02e6d..645eceb04b 100644
--- a/doc/src/sgml/ref/pgupgrade.sgml
+++ b/doc/src/sgml/ref/pgupgrade.sgml
@@ -262,6 +262,31 @@ PostgreSQL documentation
       </listitem>
      </varlistentry>
 
+     <varlistentry>
+      <term><option>--initdb</option></term>
+      <listitem>
+       <para>
+        Create the new cluster automatically by running
+        <command>initdb</command> before upgrading, instead of requiring the
+        user to have created it manually.  The WAL segment size, data checksum
+        setting, encoding, and locale are derived from the old cluster so that
+        <application>pg_upgrade</application> can verify compatibility.
+       </para>
+       <para>
+        The new cluster data directory specified with
+        <option>-D</option>/<option>--new-datadir</option> must not already
+        exist when this option is given; if it does,
+        <application>pg_upgrade</application> will exit with an error.
+       </para>
+       <para>
+        This option cannot be combined with
+        <option>-c</option>/<option>--check</option>, because
+        <option>--check</option> is read-only and must not create the new
+        cluster.
+       </para>
+      </listitem>
+     </varlistentry>
+
      <varlistentry>
       <term><option>--no-statistics</option></term>
       <listitem>
@@ -373,6 +398,108 @@ PostgreSQL documentation
       </listitem>
      </varlistentry>
 
+     <varlistentry>
+      <term><option>--wal-upgrade</option></term>
+      <listitem>
+       <para>
+        Capture the entire upgrade as write-ahead log (WAL) so that it is
+        replayable, and leave the new cluster ready to start read-write on its
+        own.  The new cluster comes up on its first start with no separate
+        commit step, exactly as an ordinary upgraded cluster would.
+       </para>
+       <para>
+        Compared with a plain upgrade, <option>--wal-upgrade</option> keeps the
+        old cluster intact so the upgrade can be reverted (see
+        <option>--wal-upgrade-rollback</option>) until it is explicitly retired
+        (see <option>--wal-upgrade-delete-old</option>), and it makes the
+        upgraded state streamable so a standby can be re-provisioned from the
+        upgraded primary by ordinary replication rather than a fresh base backup.
+       </para>
+       <para>
+        A replacement standby need not even be initialized with
+        <command>initdb</command>: an empty data directory containing only its
+        configuration, a <filename>standby.signal</filename>, a
+        <filename>pg_upgrade.signal</filename> sentinel (whose contents are the
+        path of this standby's retained pre-upgrade data directory, from which
+        user relations are linked in), and
+        <varname>primary_conninfo</varname> pointing at the upgraded primary is
+        sufficient.  On its first start the server synthesizes the control file
+        and <filename>PG_VERSION</filename>, fetches the upgrade anchor from the
+        primary over the replication connection, and streams the upgrade in,
+        coming up as a hot standby of the new-version primary.
+       </para>
+       <para>
+        It may be combined with any transfer mode.  With
+        <option>--copy</option> or <option>--clone</option> the old cluster's
+        files are duplicated, so it stays intact and the upgrade is revertable.
+        <option>--link</option> and <option>--swap</option> also work, but they
+        disable the old cluster (as in an ordinary upgrade), so those upgrades
+        are forward-only: <option>--wal-upgrade-rollback</option> then has
+        nothing to revert to.  (<option>--link</option> shares the old cluster's
+        files, and <option>--swap</option> moves them into the new cluster.)
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry>
+      <term><option>--wal-upgrade-rollback</option></term>
+      <listitem>
+       <para>
+        Discard a cluster produced by <option>--wal-upgrade</option> and return
+        to the old cluster, which was never modified.  The new cluster data
+        directory given with <option>-D</option>/<option>--new-datadir</option>
+        is removed; the operator then simply restarts on the old data directory
+        with the old binaries.
+       </para>
+       <para>
+        Rollback is available whenever the old cluster is intact.  If the old
+        cluster is unusable &mdash; consumed by <option>--swap</option>, damaged,
+        or already started after the upgrade &mdash; there is nothing safe to
+        return to, so the command exits with an error.  If the new cluster has
+        already been started and taken writes, rolling back discards them; the
+        command warns rather than blocks, leaving that judgement to the
+        operator.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry>
+      <term><option>--wal-upgrade-delete-old</option></term>
+      <listitem>
+       <para>
+        Retire the old cluster once the operator is confident in the upgrade.
+        The old cluster data directory given with
+        <option>-d</option>/<option>--old-datadir</option> is removed.  This
+        requires a fully upgraded new cluster
+        (<option>-D</option>/<option>--new-datadir</option>), so the old cluster
+        is never removed unless a working replacement exists.
+       </para>
+       <para>
+        <application>pg_upgrade</application> does not distinguish a primary from
+        a standby: to clean up a replica set, run this command on each node
+        whose old cluster should be removed.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry>
+      <term><option>--wal-upgrade-signal-handoff</option></term>
+      <listitem>
+       <para>
+        Emit a handoff trigger into the live old cluster's WAL and then shut the
+        old cluster down at that point, so that streaming standbys following it
+        stand down before the upgrade.  Shutting the old cluster down as part of
+        this step ensures no transaction appends WAL after the handoff record,
+        which would otherwise leave standbys stopping short of the primary's
+        final state.  Requires the old cluster's data directory
+        (<option>-d</option>/<option>--old-datadir</option>) and bin directory
+        (<option>-b</option>/<option>--old-bindir</option>).  This is used before
+        a <option>--wal-upgrade</option> run in replicated deployments; it does
+        not itself upgrade anything.
+       </para>
+      </listitem>
+     </varlistentry>
+
      <varlistentry>
       <term><option>-?</option></term>
       <term><option>--help</option></term>
@@ -462,6 +589,12 @@ make prefix=/usr/local/pgsql.new install
      prebuilt installers do this step automatically. There is no need to
      start the new cluster.
     </para>
+    <para>
+     Alternatively, pass <option>--initdb</option> to
+     <application>pg_upgrade</application> to have it run
+     <command>initdb</command> automatically, deriving the required settings
+     from the old cluster.  In that case this manual step can be skipped.
+    </para>
    </step>
 
    <step>
diff --git a/src/backend/access/rmgrdesc/Makefile b/src/backend/access/rmgrdesc/Makefile
index cd95eec37f..601c30dd5a 100644
--- a/src/backend/access/rmgrdesc/Makefile
+++ b/src/backend/access/rmgrdesc/Makefile
@@ -10,6 +10,7 @@ include $(top_builddir)/src/Makefile.global
 
 OBJS = \
 	brindesc.o \
+	pgupgradedesc.o \
 	clogdesc.o \
 	committsdesc.o \
 	dbasedesc.o \
diff --git a/src/backend/access/rmgrdesc/meson.build b/src/backend/access/rmgrdesc/meson.build
index d9000ccd9f..5070a526d3 100644
--- a/src/backend/access/rmgrdesc/meson.build
+++ b/src/backend/access/rmgrdesc/meson.build
@@ -14,6 +14,7 @@ rmgr_desc_sources = files(
   'logicalmsgdesc.c',
   'mxactdesc.c',
   'nbtdesc.c',
+  'pgupgradedesc.c',
   'relmapdesc.c',
   'replorigindesc.c',
   'rmgrdesc_utils.c',
diff --git a/src/backend/access/rmgrdesc/pgupgradedesc.c b/src/backend/access/rmgrdesc/pgupgradedesc.c
new file mode 100644
index 0000000000..6ffe85848b
--- /dev/null
+++ b/src/backend/access/rmgrdesc/pgupgradedesc.c
@@ -0,0 +1,170 @@
+/*-------------------------------------------------------------------------
+ *
+ * pgupgradedesc.c
+ *	  rmgr descriptor routines for RM_PG_UPGRADE_ID WAL records.
+ *
+ * Portions Copyright (c) 1996-2026, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/access/rmgrdesc/pgupgradedesc.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/pgupgrade_wal.h"
+#include "access/transam.h"		/* FirstNormalObjectId */
+#include "access/xlogreader.h"
+#include "catalog/pg_control.h"
+#include "lib/stringinfo.h"
+
+void
+pg_upgrade_desc(StringInfo buf, XLogReaderState *record)
+{
+	char	   *rec = XLogRecGetData(record);
+	uint8		info = XLogRecGetInfo(record) & ~XLR_INFO_MASK;
+
+	if (info == XLOG_UPGRADE_START || info == XLOG_UPGRADE_COMPLETE)
+	{
+		xl_pg_upgrade xlrec;
+
+		memcpy(&xlrec, rec, SizeOfXLPgUpgrade);
+		appendStringInfo(buf, "old_major_version %u; new_major_version %u; time %lld",
+						 xlrec.old_major_version,
+						 xlrec.new_major_version,
+						 (long long) xlrec.upgrade_time);
+	}
+	else if (info == XLOG_UPGRADE_SLRU_DATA)
+	{
+		xl_upgrade_slru_data xlrec;
+		const char *slru_names[] = UPGRADE_SLRU_DIRS;
+
+		memcpy(&xlrec, rec, SizeOfXLUpgradeSlruData);
+		appendStringInfo(buf, "slru %s; segs %04" PRIX64 "..%04" PRIX64 "; bytes %u",
+						 xlrec.slru_type < 3 ? slru_names[xlrec.slru_type] : "unknown",
+						 xlrec.first_seg,
+						 xlrec.last_seg,
+						 xlrec.total_bytes);
+	}
+	else if (info == XLOG_UPGRADE_RELFILE_DATA)
+	{
+		/* Batched: [entry][data][entry][data]...  Summarize the entries. */
+		char	   *ptr = rec;
+		char	   *end = rec + XLogRecGetDataLen(record);
+		int			nentries = 0;
+		int			nuser = 0;
+		uint64		total = 0;
+		xl_upgrade_relfile_entry first;
+
+		while (ptr + SizeOfXLUpgradeRelfileEntry <= end)
+		{
+			xl_upgrade_relfile_entry ent;
+
+			memcpy(&ent, ptr, SizeOfXLUpgradeRelfileEntry);
+			if (nentries == 0)
+				first = ent;
+			nentries++;
+
+			/*
+			 * User relations are listed in the RELINK manifest, not carried
+			 * as data in a RELFILE record.  Count any user relfilenumbers
+			 * that do appear here, so the "user" total in pg_waldump is 0 for
+			 * a schema-only window.
+			 */
+			if (ent.relfilenumber >= FirstNormalObjectId)
+				nuser++;
+			total += ent.nbytes;
+			ptr += SizeOfXLUpgradeRelfileEntry + ent.nbytes;
+		}
+		appendStringInfo(buf, "%d files (%d user); %llu bytes; first rel %u/%u/%u seg %u blkoff %u",
+						 nentries, nuser, (unsigned long long) total,
+						 nentries ? first.tablespace_oid : 0,
+						 nentries ? first.database_oid : 0,
+						 nentries ? first.relfilenumber : 0,
+						 nentries ? first.segno : 0,
+						 nentries ? first.blockoff : 0);
+	}
+	else if (info == XLOG_UPGRADE_RELINK)
+	{
+		/* Manifest of user relations to link on the standby: no file data. */
+		char	   *ptr = rec;
+		char	   *end = rec + XLogRecGetDataLen(record);
+		int			nentries = 0;
+		xl_upgrade_relink_entry first;
+
+		while (ptr + SizeOfXLUpgradeRelinkEntry <= end)
+		{
+			xl_upgrade_relink_entry ent;
+
+			memcpy(&ent, ptr, SizeOfXLUpgradeRelinkEntry);
+			if (nentries == 0)
+				first = ent;
+			nentries++;
+			ptr += SizeOfXLUpgradeRelinkEntry;
+		}
+		appendStringInfo(buf, "%d files to relink; first rel %u/%u/%u fork %u seg %u",
+						 nentries,
+						 nentries ? first.tablespace_oid : 0,
+						 nentries ? first.database_oid : 0,
+						 nentries ? first.relfilenumber : 0,
+						 nentries ? first.forknum : 0,
+						 nentries ? first.segno : 0);
+	}
+	else if (info == XLOG_UPGRADE_RAWFILE)
+	{
+		xl_upgrade_rawfile xlrec;
+		char	   *path = rec + SizeOfXLUpgradeRawfile;
+
+		memcpy(&xlrec, rec, SizeOfXLUpgradeRawfile);
+		appendStringInfo(buf, "rawfile \"%.*s\"; bytes %u",
+						 (int) xlrec.path_len, path, xlrec.data_len);
+	}
+	else if (info == XLOG_UPGRADE_DIRTREE)
+	{
+		xl_upgrade_dirtree xlrec;
+		char	   *first = rec + SizeOfXLUpgradeDirtree;
+
+		memcpy(&xlrec, rec, SizeOfXLUpgradeDirtree);
+		appendStringInfo(buf, "dirs %u (%u bytes); symlinks %u (%u bytes); first \"%s\"",
+						 xlrec.ndirs, xlrec.dir_bytes,
+						 xlrec.nsymlinks, xlrec.sym_bytes,
+						 xlrec.ndirs > 0 ? first : "");
+	}
+	else if (info == XLOG_UPGRADE_HANDOFF)
+	{
+		xl_pg_upgrade_handoff xlrec;
+
+		memcpy(&xlrec, rec, SizeOfXLPgUpgradeHandoff);
+		appendStringInfo(buf, "old_major_version %u; target_major_version %u; time %lld",
+						 xlrec.old_major_version,
+						 xlrec.target_major_version,
+						 (long long) xlrec.handoff_time);
+	}
+}
+
+const char *
+pg_upgrade_identify(uint8 info)
+{
+	switch (info & ~XLR_INFO_MASK)
+	{
+		case XLOG_UPGRADE_START:
+			return "PG_UPGRADE_START";
+		case XLOG_UPGRADE_COMPLETE:
+			return "PG_UPGRADE_COMPLETE";
+		case XLOG_UPGRADE_SLRU_DATA:
+			return "UPGRADE_SLRU_DATA";
+		case XLOG_UPGRADE_RELFILE_DATA:
+			return "UPGRADE_RELFILE_DATA";
+		case XLOG_UPGRADE_RELINK:
+			return "UPGRADE_RELINK";
+		case XLOG_UPGRADE_RAWFILE:
+			return "UPGRADE_RAWFILE";
+		case XLOG_UPGRADE_DIRTREE:
+			return "UPGRADE_DIRTREE";
+		case XLOG_UPGRADE_HANDOFF:
+			return "PG_UPGRADE_HANDOFF";
+	}
+	return NULL;
+}
diff --git a/src/backend/access/rmgrdesc/xlogdesc.c b/src/backend/access/rmgrdesc/xlogdesc.c
index 2468a7d257..190a22b564 100644
--- a/src/backend/access/rmgrdesc/xlogdesc.c
+++ b/src/backend/access/rmgrdesc/xlogdesc.c
@@ -218,6 +218,7 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 	{
 		/* no further information to print */
 	}
+	/* Upgrade records are handled by pg_upgrade_desc() via RM_PG_UPGRADE_ID */
 }
 
 const char *
@@ -225,6 +226,16 @@ xlog_identify(uint8 info)
 {
 	const char *id = NULL;
 
+	/*
+	 * Upgrade record types must be checked before masking, since
+	 * 0xC0/0xC1/0xC2 all reduce to 0xC0 after applying ~XLR_INFO_MASK (0xF0).
+	 */
+
+	/*
+	 * Upgrade records are handled by pg_upgrade_identify() via
+	 * RM_PG_UPGRADE_ID
+	 */
+
 	switch (info & ~XLR_INFO_MASK)
 	{
 		case XLOG_CHECKPOINT_SHUTDOWN:
diff --git a/src/backend/access/transam/Makefile b/src/backend/access/transam/Makefile
index a32f473e0a..81294a8f96 100644
--- a/src/backend/access/transam/Makefile
+++ b/src/backend/access/transam/Makefile
@@ -37,7 +37,8 @@ OBJS = \
 	xlogrecovery.o \
 	xlogstats.o \
 	xlogutils.o \
-	xlogwait.o
+	xlogwait.o \
+	pgupgrade_wal.o
 
 include $(top_srcdir)/src/backend/common.mk
 
diff --git a/src/backend/access/transam/clog.c b/src/backend/access/transam/clog.c
index 75012d4b8f..3eb6e4f5f0 100644
--- a/src/backend/access/transam/clog.c
+++ b/src/backend/access/transam/clog.c
@@ -1115,6 +1115,16 @@ clog_redo(XLogReaderState *record)
 		elog(PANIC, "clog_redo: unknown op code %u", info);
 }
 
+/*
+ * Restore a captured pg_xact (CLOG) segment during --wal-upgrade replay.
+ * Thin wrapper exposing XactCtl to the RM_PG_UPGRADE_ID redo handler.
+ */
+void
+CLOGUpgradeRestoreSegment(int64 segno, const char *data, Size datalen)
+{
+	SlruUpgradeRestoreSegment(XactCtl, segno, data, datalen);
+}
+
 /*
  * Entrypoint for sync.c to sync clog files.
  */
diff --git a/src/backend/access/transam/meson.build b/src/backend/access/transam/meson.build
index 06aadc7f31..cabc681622 100644
--- a/src/backend/access/transam/meson.build
+++ b/src/backend/access/transam/meson.build
@@ -6,6 +6,7 @@ backend_sources += files(
   'generic_xlog.c',
   'multixact.c',
   'parallel.c',
+  'pgupgrade_wal.c',
   'rmgr.c',
   'slru.c',
   'subtrans.c',
diff --git a/src/backend/access/transam/multixact.c b/src/backend/access/transam/multixact.c
index 8c69465813..7856ced105 100644
--- a/src/backend/access/transam/multixact.c
+++ b/src/backend/access/transam/multixact.c
@@ -2995,6 +2995,23 @@ multixact_redo(XLogReaderState *record)
 		elog(PANIC, "multixact_redo: unknown op code %u", info);
 }
 
+/*
+ * Restore captured pg_multixact/offsets and pg_multixact/members segments
+ * during --wal-upgrade replay.  Thin wrappers exposing the static SLRU
+ * ctls to the RM_PG_UPGRADE_ID redo handler.
+ */
+void
+MultiXactOffsetUpgradeRestoreSegment(int64 segno, const char *data, Size datalen)
+{
+	SlruUpgradeRestoreSegment(MultiXactOffsetCtl, segno, data, datalen);
+}
+
+void
+MultiXactMemberUpgradeRestoreSegment(int64 segno, const char *data, Size datalen)
+{
+	SlruUpgradeRestoreSegment(MultiXactMemberCtl, segno, data, datalen);
+}
+
 /*
  * Entrypoint for sync.c to sync offsets files.
  */
